unit edit;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Controls.Presentation, FMX.edit;

type
  TForm2 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    SpeedButton1: TSpeedButton;
    procedure FormPaint(Sender: TObject; Canvas: TCanvas; const ARect: TRectF);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses FMX.textlayout;
{$R *.fmx}

procedure TForm2.FormPaint(Sender: TObject; Canvas: TCanvas;
  const ARect: TRectF);
var
  y: Single;
  AText: TTextLayout;
  procedure TextOut(ALeft, ATop: Single; S: String; AVert: Boolean);
  var
    tr: TRectF;
  begin
    AText.BeginUpdate;
    AText.Text := S;
    tr := AText.TextRect;
    if AVert then
      AText.TopLeft := PointF(ALeft, ATop - tr.Height / 2)
    else
      AText.TopLeft := PointF(ALeft - tr.Width / 2, ATop);
    AText.EndUpdate;
    AText.RenderLayout(Canvas);
  end;

begin
  Canvas.BeginScene();
  try
    y := ARect.Top;
    AText := TTextLayoutManager.TextLayoutByCanvas(Canvas.ClassType)
      .Create(Canvas);
    AText.BeginUpdate;
    AText.Color := TAlphaColors.Black;
    AText.HorizontalAlign := TTextAlign.Leading;
    AText.VerticalAlign := TTextAlign.Leading;
    AText.Font := Canvas.Font;
    AText.Font.Size := 9;
    AText.Opacity := 1;
    AText.MaxSize := PointF(1000, 1000);
    AText.EndUpdate;
    Canvas.Stroke.Color := TAlphaColors.Gray;
    Canvas.Stroke.Kind := TBrushKind.Solid;
    Canvas.Fill.Color := TAlphaColors.Black;
    while y < ARect.Bottom do
    begin
      y := Trunc(y / 10) * 1;
      y := y + 10;
      if (Trunc(y) mod 50) = 0 then
      begin
        Canvas.Stroke.Color := TAlphaColors.Black;
        Canvas.DrawLine(PointF(0, y), PointF(10, y), 1);
        Canvas.Stroke.Color := TAlphaColors.Gray;
        TextOut(10, y, FloatToStr(y), true);
      end
      else
        Canvas.DrawLine(PointF(0, y), PointF(5, y), 1);
    end;
  finally
    Canvas.EndScene;
    FreeAndNil(AText);
  end;
end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

end.
