unit memo;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes,
  System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.ScrollBox,
  FMX.memo, FMX.Controls.Presentation, FMX.StdCtrls;

type
  TForm3 = class(TForm)
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    procedure FormPaint(Sender: TObject; Canvas: TCanvas; const ARect: TRectF);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

uses FMX.textlayout;
{$R *.fmx}

procedure TForm3.FormPaint(Sender: TObject; Canvas: TCanvas;
  const ARect: TRectF);
var
  y, th: Single;
  AText: TTextLayout;
begin
  Canvas.BeginScene();
  try
    y := ARect.Top;
    AText := TTextLayoutManager.TextLayoutByCanvas(Canvas.ClassType)
      .Create(Canvas);
    AText.BeginUpdate;
    AText.Font.Size := 9;
    AText.Color := TAlphaColors.Black;
    AText.HorizontalAlign := TTextAlign.Leading;
    AText.VerticalAlign := TTextAlign.Leading;
    AText.Font := Canvas.Font;
    AText.Opacity := 1;
    AText.EndUpdate;
    Canvas.Stroke.Color := TAlphaColors.Black;
    Canvas.Stroke.Kind := TBrushKind.Solid;
    Canvas.Fill.Color := TAlphaColors.Black;
    while y < ARect.Bottom do
    begin
      y := Trunc(y / 10) * 10;
      y := y + 10;
      Canvas.DrawLine(PointF(0, y), PointF(10, y), 1);
      if (Trunc(y) mod 50) = 0 then
      begin
        AText.BeginUpdate;
        AText.Text := IntToStr(Trunc(y));
        th := AText.TextHeight;
        AText.TopLeft := PointF(10, y - th / 2);
        AText.MaxSize := PointF(100, th);
        AText.EndUpdate;
        AText.RenderLayout(Canvas);
      end;
    end;
  finally
    Canvas.EndScene;
    FreeAndNil(AText);
  end;
end;

procedure TForm3.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

end.
